/*
 * Copyright 2011 Steven Gribble
 *
 *  This file is part of the UW CSE 333 course project sequence
 *  (333proj).
 *
 *  333proj is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  333proj is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 333proj.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <map>
#include <string>
#include <sstream>

#include "./libhw2/TwitterAPI.h"
#include "./HttpUtils.h"
#include "./TwitterCloud.h"
#include "./TwitterSearch.h"
#include "./FormReader.h"

namespace hw3 {

bool FormReader::ProcessForm(std::string *str) {
  URLParser parser;
  parser.Parse(uri_);
  std::map<std::string, std::string> args = parser.get_args();

  // Is this a twitter cloud query?
  std::string tcquery = args["twittercloud"];
  if (tcquery != "") {
    *str = ProcessTwitterCloudQuery(tcquery);
    return true;
  }

  // Is this a twitter search query?
  std::string tsquery = args["twittersearch"];
  if (tsquery != "") {
    *str = ProcessTwitterSearch(tsquery);
    return true;
  }

  // Unrecognized query.
  return false;
}

}  // namespace hw3
