/*
 * Copyright 2012 Steven Gribble
 *
 *  This file is part of the UW CSE333 project sequence (333proj12).
 *
 *  333proj12 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published
 *  by the Free Software Foundation, either version 3 of the License,
 *  or (at your option) any later version.
 *
 *  333proj12 is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with 333proj12.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _HW2_HTTPCLIENT_H_
#define _HW2_HTTPCLIENT_H_

#include <stdint.h>
#include <string>

// Retrieve the URL, parse out the content, and store it in the return
// parameter "content."  On success, return true, else return false.
//
// Arguments:
//
// - hostname: DNS name or IP address of the server to connect to
// - port: port number to connect to
// - path: path within the server to fetch
// - content: a return parameter in which the content is stuffed
//
// Returns:
//
// - true on success, false on failure
bool HTTPGet(std::string hostname,
             uint16_t port,
             std::string path,
             std::string *content);

#endif  // _HW2_HTTPCLIENT_H_
